function [x,y1,y2,x1,y3,l]=three_tube_model_pt1(rG,rL,l1,l2,l3,A1,A2,A3);
%
% Find resonances and 6 dB bandwidths of 3-tube vocal tract model 

% inputs:  
%   rG=glottal impedance 
%   rL=lip impedance
%   l1=length of section 1
%   l2=length of section 2 
%   l3=length of section 3
%   A1=area of section 1 
%   A2=area of section 2
%   A3=area of section 3
%
% outputs:
%   x: x-coordinates of three-tube areas
%   y1: y-coordinates of three-tube areas
%   y2: negative of y1 (tube reflection around center)
%   x1: center line of tube x-coordinates
%   y3: center line of tube y-coordinates
%   l: total length of tube

% calculate l as the sum of l1 + l2 + l3
            l=l1+l2+l3;
            x=[0, l1, l1, l1, l1, l1+l2,l1+l2,l1+l2, l1+l2, l];
            y1=[A1, A1, A1, A2, A2, A2, A2, A3, A3, A3];
            y2=-y1;
            x1=[0, l];
            y3=[0, 0];
end

